
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>MDSLibraries.voyager_master_phil &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for MDSLibraries.voyager_master_phil</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">voyager_phil_keywords</span>
<span class="kn">import</span> <span class="nn">types</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">traceback</span>

<span class="n">module_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="vm">__file__</span><span class="p">))</span>
<span class="n">strategies</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">module_path</span><span class="p">,</span> <span class="s2">&quot;../Voyager/Strategies/&quot;</span><span class="p">)</span>
<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">strategies</span><span class="p">)</span>

<span class="n">scope_outer</span> <span class="o">=</span> <span class="s2">&quot;voyager&quot;</span>
<span class="n">scope_separator</span> <span class="o">=</span> <span class="s2">&quot;__&quot;</span>

<span class="c1">#these lists need to be manually edited as new keywords are used</span>
<div class="viewcode-block" id="master_phil_str"><a class="viewcode-back" href="../../MDSLibraries.voyager_master_phil.html#MDSLibraries.voyager_master_phil.master_phil_str">[docs]</a><span class="k">def</span> <span class="nf">master_phil_str</span><span class="p">(</span><span class="n">class_name</span><span class="p">):</span>
  <span class="k">if</span> <span class="n">class_name</span> <span class="o">==</span> <span class="s2">&quot;Input&quot;</span><span class="p">:</span>
    <span class="k">return</span> <span class="n">input_implemented</span><span class="p">([</span><span class="s1">&#39;mode&#39;</span><span class="p">,</span><span class="s1">&#39;rest&#39;</span><span class="p">])</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="n">mphil</span> <span class="o">=</span> <span class="n">input_implemented</span><span class="p">([</span><span class="s1">&#39;rest&#39;</span><span class="p">])</span>
      <span class="n">strat</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="n">class_name</span><span class="p">)</span>
      <span class="c1"># print(strat)</span>
      <span class="c1"># print(dir(strat))</span>
      <span class="n">masterphilstrat</span> <span class="o">=</span> <span class="n">strat</span><span class="o">.</span><span class="n">masterphil</span>
      <span class="n">mphil</span> <span class="o">+=</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">+</span><span class="n">masterphilstrat</span>
      <span class="k">return</span> <span class="n">mphil</span>
    <span class="k">except</span><span class="p">:</span>
      <span class="nb">print</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">exc_info</span><span class="p">())</span>
      <span class="n">traceback</span><span class="o">.</span><span class="n">print_exc</span><span class="p">(</span><span class="n">file</span><span class="o">=</span><span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="p">)</span>
      <span class="c1">#print(&quot;The given class_name&quot;,class_name,&quot;is not recognized. Exit.&quot;)</span>
      <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;The given class_name&quot;</span><span class="p">,</span><span class="n">class_name</span><span class="p">,</span><span class="s2">&quot;is not recognized&quot;</span><span class="p">)</span></div>

  <span class="c1">#else:</span>
  <span class="c1">#  members = [attr for attr in dir(phaserpipe_phil_keywords) if not callable(getattr(phaserpipe_phil_keywords, attr)) and not attr.startswith(scope_separator)]</span>
  <span class="c1">#  return build_phil_str(members)</span>

<div class="viewcode-block" id="build_phil_str"><a class="viewcode-back" href="../../MDSLibraries.voyager_master_phil.html#MDSLibraries.voyager_master_phil.build_phil_str">[docs]</a><span class="k">def</span> <span class="nf">build_phil_str</span><span class="p">(</span><span class="n">members</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;&quot;</span><span class="p">]):</span>
  <span class="n">master_phil</span> <span class="o">=</span> <span class="n">scope_outer</span> <span class="o">+</span> <span class="s2">&quot; {</span><span class="se">\n</span><span class="s2">&quot;</span>
  <span class="k">for</span> <span class="n">keyword</span> <span class="ow">in</span> <span class="n">members</span><span class="p">:</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="n">master_phil</span> <span class="o">+=</span> <span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="nb">getattr</span><span class="p">(</span><span class="n">voyager_phil_keywords</span><span class="p">,</span> <span class="n">keyword</span><span class="p">)))</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
    <span class="k">except</span><span class="p">:</span>
      <span class="k">pass</span>
    
  <span class="n">master_phil</span> <span class="o">+=</span> <span class="s2">&quot;}</span><span class="se">\n</span><span class="s2">&quot;</span>
  <span class="k">return</span> <span class="n">master_phil</span></div>

<div class="viewcode-block" id="input_implemented"><a class="viewcode-back" href="../../MDSLibraries.voyager_master_phil.html#MDSLibraries.voyager_master_phil.input_implemented">[docs]</a><span class="k">def</span> <span class="nf">input_implemented</span><span class="p">(</span><span class="n">listk</span><span class="p">):</span>
  <span class="c1">#this list needs to be manually edited as new keywords are used</span>
  <span class="k">return</span> <span class="n">build_phil_str</span><span class="p">(</span><span class="n">listk</span><span class="p">)</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
  <span class="nb">print</span> <span class="p">(</span><span class="n">master_phil_str</span><span class="p">())</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>